/**********
*   .csv  Relog Perfmon 
* Greg Linwood
* greg@SolidQualityLearning.com
* Jan 30th, 2006
*
*      
*     csv- 
* perfmon       
**********/
set nocount on
/*
* 
*/
--    
--    , 
--   tempdb..mycounters 
(countertime datetime, counterval decimal (15, 3)).
--   tempdb..mycounters.
-- ,  
declare 
   @perfdir varchar(255)  --  
                          --  csv- perfmon
 , @archivedir varchar(255)  --  
                          --   
 , @counter varchar(1000)   , 
                          -   
-- ,    
--  csv- perfmon
set @perfdir = 'C:\PerfmonLogFiles\'
-- ,     
--   (,   
--   ) 
set @archivedir = 'C:\PerfmonLogFiles\Archive\'
-- ,   , 
--    
set @counter = '\\PRODSQL1\SQLServer:
Buffer Manager\Page life expectancy'
/*
* 
*/
--  run-time ( )
declare 
   @filename varchar(200)    
                          -  
 , @sql varchar (1000)    sql
--     csv- perfmon, 
   
create table #files
(filename varchar(200), d int, f int)
--       
     
create table #counters (dt varchar(50), 
val varchar(50))
--  #files   xp_dirtree
insert #files execute 
master.dbo.xp_dirtree @perfdir, 1, 1
delete from #files where f != 1
--   ,   
declare cr cursor for
select filename from #files order by filename
open cr
fetch next from cr into @filename
while @@fetch_status = 0
 begin
  --     tempout.csv
  set @sql = 'exec master..xp_cmdshell ''relog '
  set @sql = @sql + @perfdir + 
'' + @filename + ' -c "'
  set @sql = @sql + @counter + 
'" -o ' + @perfdir + 'tempout.csv -f CSV'''
  exec(@sql)
  --     tempout.csv 
  --   #counters
  set @sql = 'bulk insert #counters from 
''' + @perfdir + 'tempout.csv'' '
  set @sql = @sql + 'with 
(FIELDTERMINATOR = '','', FIRSTROW = 2)'
  exec(@sql)
  --   tempout.csv
  set @sql = 'exec master..xp_cmdshell 
''del ' + @perfdir + 'tempout.csv'''
  exec(@sql)
  --   csv- perfmon 
  --   
  set @sql = 'exec master..xp_cmdshell 
''move ' + @perfdir + ''
  set @sql = @sql + @filename + 
' ' + @archivedir + @filename + ''''
  exec(@sql)
  --      /
  --   
  update #counters set dt = replace(dt, '"', ''), 
val = replace(val, '"', '')
  --    
  --    
  insert into tempdb..mycounters 
  select convert(datetime, dt) as dt
       , convert(decimal(15, 3), val) as val 
  from #counters where isnumeric(val) = 1
  --    #counters 
  --    
  truncate table #counters
  fetch next from cr into @filename
 end
go
--  
close cr
deallocate cr
go
--   
if object_id('tempdb..#files') > 
0 drop table #files;
if object_id('tempdb..#counters') > 
0 drop table #counters;
go
--     
select top 20 * from tempdb..mycounters

